html {
    height: 100%;
}

body.board-view {
    display: flex;
    flex-flow: column;
    height: 100%;
}

body.blur > header, body.blur > #board-columns {
    filter: blur(1mm);
}

#board-columns {
    flex: 1 0 12cm;
    display: flex;
    flex-flow: row;
    padding: 1mm;
    padding-top: 0; /* le header n'a pas de séparation visuelle avec les colonnes */
    padding-right: 0; /* astuce ci-dessous */

    overflow: auto;
}

/* Quand la scrollbar horizontal apparait, il n'y a pas de marge droite après
   la dernière colonne. Pour remédier à cela, j'utilise la 1re astuce dans cet
   article :
   https://itnext.io/horizontal-overflow-with-flexbox-css-64f530495303
*/
#board-columns::after {
    content: '';
    flex: 0 0 1mm;
}

.board-column {
    margin: 1mm;
    margin-top: 0; /* le header n'a pas de séparation visuelle avec les colonnes */
    background-color: white;

    /*box-shadow: 0 0.5mm 1mm #0003;*/
    border-radius: 3mm;
    padding: 0;

    flex: 1 0 6cm;

    display: flex;
    flex-flow: column;

    overflow: hidden; /* afin que la scrollbar soit rognée en bas à droite */
}

.board-column header {
    display: flex;
    flex-flow: row;
    justify-content: space-between;
    align-items: center;
    border-bottom: solid 1px #0002;
}

.board-column header h3 {
    margin: 3mm 0;
    margin-left: 3mm;

    text-overflow: ellipsis;
    overflow: hidden;
    white-space: nowrap;
}

.header-actions {
    display: flex;
    flex-flow: row-reverse;
    align-items: center;
    margin-left: 3mm;
    align-self: start;
}

.board-column header .task-sort {
    margin: 3mm 0;
}

.board-column header .task-sort:first-child {
    margin-right: 3mm;
}

.board-column header .add-task-button {
    font-size: 1.3em;
    padding: 3mm 4mm;
    text-decoration: none;
    color: #000a;
    transition-duration: 100ms;
    font-weight: bold;
}
.board-column header .add-task-button:hover {
    background-color: var(--highlight-background);
    color: var(--clickable-text);
}

.board-column header .add-task-button:active {
    transform: scale(0.95);
    background-color: var(--highlight-background-clicked);
    color: var(--clickable-text);
}

.task-list {
    flex: 1;
    overflow-y: auto;

    padding: 3mm;
    /* there is a 2mm margin-bottom on .task */
    padding-bottom: 1mm;
}

.task.dragging {
    opacity: 0.5;
}

/* task editor */

#task-editor-overlay {
    position:absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background-color: #0005;
    overflow-y: auto;
}

#task-editor-content {
    max-width: 15cm;
    margin: 1cm auto;
}

#task-editor-content > h1 {
    color: white;
    text-shadow: 0 1mm 2mm #0003;
}

#task-editor-formatting-bar {
    margin-bottom: 3mm;
    box-shadow: 0 1mm 2mm #0003;
    border-radius: 2mm;
    padding: 0;
    background-color: white;

    list-style: none;
    display: flex;
    flex-flow: row wrap;
    justify-content: space-between;
    overflow: hidden;
}

#task-editor-formatting-bar li {
    transition-duration: 100ms;

    flex: 1;
    text-align: center;

    border-radius: 2mm;

    display: flex;
}

#task-editor-formatting-bar li:hover {
    color: var(--clickable-text);
    background-color: var(--highlight-background);
}

#task-editor-formatting-bar li:active {
    transform: scale(0.95);
    color: var(--clickable-text);
    background-color: var(--highlight-background-clicked);
}

#task-editor-formatting-bar a {
    color: inherit;
    text-decoration: none;
    padding: 2mm;

    display: inline-block;
    flex: 1;
}


#task-editor-task {
    margin-bottom: 3mm;
    box-shadow: 0 1mm 2mm #0003;
    padding: 2mm;
    border-radius: 2mm;
    min-height: 4cm;


    transition: 200ms;
}

#task-editor-description {
    width: 100%;
    min-width: 100%;
    max-width: 100%;
    min-height: 5em;

    background-color: transparent;
    border: none;
    font-size: 1em;
    font-family: inherit;
    color: inherit;
    border-bottom: solid 1px #0006;
}

#task-editor-description-preview {
    min-height: 5em;
    word-break: break-all;
}

#task-editor-task label {
    text-transform: uppercase;
    font-size: 0.8em;
    font-weight: bold;
    color: #0006;
    display: inline-block;
    padding: 1.5mm 0;
}

/*#task-editor-assigned-user {
    background-color: transparent;
    border: solid 1px #0004;
    padding: 0.5mm 2mm;
    border-radius: 1.5mm;

    font-size: 0.8em;
    color: inherit;
    font-family: inherit;
}*/

#task-editor-colors {
    margin-bottom: 5mm;
    display: flex;
    flex-flow: row wrap;
    justify-content: space-between;
    background-color: white;
    border-radius: 6mm;
    box-shadow: 0 1mm 2mm #0003;
    padding: 2mm;
}

#task-editor-colors > .task-color {
    width: 6mm;
    height: 6mm;
    border-radius: 3mm;
    border: solid 1px #0006;
    margin: 1mm;
    cursor: pointer;
    transition: 100ms;

    background-repeat: no-repeat;
    background-size: 4mm;
    background-position: center;
}

#task-editor-colors > .task-color:hover {
    transform: scale(1.25);
}

#task-editor-colors > .task-color.selected {
    border-color: #000a;
    transform: scale(1.5);
    background-image: url("../img/selected.svg");
}

#task-editor-save-row {
    display: flex;
    flex-flow: row-reverse wrap;
    justify-content: space-between;
}

.task-editor-button {
    color: inherit;
    background-color: white;

    border: none;
    border-radius: 1cm;
    padding: 3mm 6mm;
    box-shadow: 0 1mm 2mm #0003;
    margin: 0;
    margin-bottom: 2mm;

    transition-duration: 100ms;

    font-family: inherit;
    font-weight: bold;
    text-transform: uppercase;
    font-size: 0.8em;

    background-repeat: no-repeat;
    background-size: contain;
    background-position: center;
}

.task-editor-button:not([disabled]):hover {
    background-color: var(--highlight-background);
    color: var(--clickable-text);

    cursor: pointer;
}

.task-editor-button:not([disabled]):active {
    transform: scale(0.95);
    background-color: var(--highlight-background-clicked);
    color: var(--clickable-text);
}

.task-editor-button.loading {
    color: transparent;

    background-image: url("../img/loading.svg");
}
